
#include <allegro.h>
#include <iostream>
#include <vector>
#include <math.h>
#include <list>
#include <set>
#include <fstream>
#include <algorithm>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif
#include "random.hpp"
#include "map.txt"

struct Pos{
	float x;
	float y;
};

using namespace std;
const float PI = 3.1415926535;
BITMAP* buffer;
BITMAP* title;
BITMAP* bg;
BITMAP* icons;
FONT* f;

int endtimer=0;

/*
 
map

 101
 101
 101
 111
 
 
 
 */
const int FRAMERATE=60;

char scoretxt[100];
int score=0;
int timeleft=60*FRAMERATE;
char timetxt[100];


const int SCREEN_WIDTH=640;
const int SCREEN_HEIGHT=480;

bool upheld=false;
bool downheld=false;
bool spaceheld=true;
bool leftheld=true;
bool rightheld=true;
int talkcount;
bool talking;
int curline;

const int map_w=10;
const int map_h=7;
const int TILE_SIZE=100;

int brightness;
char itemcounttext[30];

const int TILE_WIDTH=11;
const int TILE_HEIGHT=14;

const int endx=55; const int endy=8;


const int COL_MAX=50;
Pos collectables[COL_MAX];
int colcount;
int colmax;

int gtime;

int magenta;
int red;
int pink;
int lightred;
int black;
int white;
int green;
int lightgreen;
int orange;
int purp0;
int purp1;
int purp2;
int grey;
int lightgrey;
int blue;
int yellow;
int bgcol;

void cutbars()
{
	rectfill(buffer, 0, 0, SCREEN_WIDTH, 200, black);
	rectfill(buffer, 0, SCREEN_HEIGHT-200, SCREEN_WIDTH, SCREEN_HEIGHT, black);
}

int itemcount=0;


bool spacepressed;


bool quit=false;


int algdone=false;

char leveltitle[200];



int levelseed;
const int MARGIN=10;
const int TRIANGLE_SIZE = 50;
const int ICON_RADIUS = 10;
const int FONT_HEIGHT=8;
int bltime;
int endmenutimer;
bool endmode;

bool gameover;
uint musictimer;

bool dragmode;
uint curnote;

uint melody_length=10;
int level_code;


Pos pos;
Pos vel;
int control;


const int People_Count=10;
Pos peeps[People_Count];
Pos peepsvel[People_Count];

bool deadly[46][61];

Pos target;
bool inbase[2];

Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies

#include "sound.hpp"
#include "timer.hpp"

const int ts=13;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

int leveltimer;

int levelgoal;



bool stoppedfather;
bool upblock;



const int T1=35;
const int T2=25;

int killtimer=0;

Pos oldmouse;
Pos newmouse;
int scoremodifier;

const Pos anchor={SCREEN_WIDTH/2,SCREEN_HEIGHT/2};
Pos p1,p2;
Pos f1,f2;
Pos v1,v2;

inline float len(Pos a, Pos b)
{
	return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
inline float len(Pos a)
{
	return sqrt((a.x)*(a.x)+(a.y)*(a.y));
}
class LevelLoop
	{
	public:
		static void initialize()
		{
			timeleft=60*FRAMERATE;
			colmax=3;
			colcount=0;
			sprintf(scoretxt, "%d",score);
			score=0;
			itemcount=0;
			escpressed=true;
			score=0;
			sprintf(scoretxt,"0");
			quit=false;
			finishedtitle=false;
			spaceheld=true;
			escpressed=true;
			leftheld=true;
			rightheld=true;
			talking=false;
			talkcount=0;
			srand(time(0));
			p1.x=SCREEN_WIDTH/2;
			p1.y=(SCREEN_HEIGHT*4)/6;
			p2.x=SCREEN_WIDTH/2;
			sprintf(timetxt,"time left:%d",timeleft/60);

			p2.y=(SCREEN_HEIGHT*5)/6;
			v1.x=0;
			v1.y=0;
			v2.x=0;
			v2.y=0;
			
			gtime=0;
		
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			
			if (key[KEY_ESC])
			{
				if (!escpressed)
				{
					quit=true;
				}
			}
			else escpressed=false;
			
			timeleft--;
			if (timeleft==0)
			{
				finishedtitle=true;
			}
			if (timeleft%60==0)
			{
				sprintf(timetxt,"time left:%d",timeleft/60);
			}
			gtime++;
			if (gtime%300==0)
			{
				colmax=min(colmax+1,COL_MAX-1);
			}
			
			
			for (int i=0;i<colcount;i++)
			{
				collectables[i].y++;
				if (collectables[i].y>SCREEN_HEIGHT+20)
				{
					swap(collectables[i],collectables[colcount-1]);
					i--;
					colcount--;
				}
			}
			
			for (int i=0;i<colcount;i++)
			{
				if (len(collectables[i],p1)<27||(len(collectables[i],p2)<27))
				{
					swap(collectables[i],collectables[colcount-1]);
					i--;
					colcount--;
					score++;
					playsample(0);
					sprintf(scoretxt, "%d",score);
				}
			}
			
			while (colcount<colmax)
			{
				collectables[colcount].y=-5;
				collectables[colcount].x=((SCREEN_WIDTH-SCREEN_HEIGHT))+(rand()%SCREEN_HEIGHT*4/6);
				colcount++;
			}
			
			const float g=0.03f;
			const float a=0.05f;
			
			f1.x=0;
			f1.y=g;
			f2.x=0;
			f2.y=g;
			
			if (key[KEY_W])
			{
				f1.y-=1.5*a;
			}
			if (key[KEY_S])
			{
				f1.y+=1.5*a;
			}
			if (key[KEY_A])
			{
				f1.x-=1.5*a;
			}
			if (key[KEY_D])
			{
				f1.x+=1.5*a;
			}
			
			if (key[KEY_UP])
			{
				f2.y-=a;
			}
			if (key[KEY_DOWN])
			{
				f2.y+=a;
			}
			if (key[KEY_LEFT])
			{
				f2.x-=a;
			}
			if (key[KEY_RIGHT])
			{
				f2.x+=a;
			}
			
			//elastic things
			
			v1.x+=f1.x;
			v1.y+=f1.y;
			v2.x+=f2.x;
			v2.y+=f2.y;
			
			//apply pendulum contraint
			p1.x+=v1.x;
			p1.y+=v1.y;
			p2.x+=v2.x;
			p2.y+=v2.y;
			
			
			//apply spring forces
			
			Pos vect1;
			Pos vect2;

			Pos u1;
			
			Pos u2;
			
			
			for (int i=0;i<11;i++)
			{
				
				vect1=(Pos){p1.x-anchor.x,p1.y-anchor.y};
				vect2=(Pos){p2.x-p1.x,p2.y-p1.y};
				
				int l1=len(anchor,p1);
				int l2=len(p2,p1);
				float m1=(float)SCREEN_HEIGHT/6-l1;
				float m2=(float)SCREEN_HEIGHT/6-l2;
				
				u1.x=vect1.x/l1;
				u1.y=vect1.y/l1;
				u2.x=vect2.x/l1;
				u2.y=vect2.y/l1;
			
				const float d=0.01f;
				f1.x=u1.x*m1*d;
				f1.y=u1.y*m1*d;
			
				f2.x=u2.x*m2*d;
				f2.y=u2.y*m2*d;
				f1.x+=-u2.x*m2*d;
				f1.y+=-u2.y*m2*d;
			
				v1.x+=f1.x;
				v1.y+=f1.y;
				v2.x+=f2.x;
				v2.y+=f2.y;
			
				//apply pendulum contraint
				p1.x+=v1.x;
				p1.y+=v1.y;
				p2.x+=v2.x;
				p2.y+=v2.y;
			}
			
			//constrain velocities
			
			v1.x*=0.95f;
			v1.y*=0.95f;
			v2.x*=0.95f;
			v2.y*=0.95f;
			
		}
		static void draw()
		{
			blit(bg, buffer,0,0,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
			masked_blit(icons, buffer, 96, 0, SCREEN_WIDTH/2-24, SCREEN_HEIGHT/2-24, 48, 48); 

			line(buffer,anchor.x,anchor.y,p1.x,p1.y,white);
			line(buffer,p2.x,p2.y,p1.x,p1.y,white);
			masked_blit(icons, buffer, 0, 0, p1.x-24, p1.y-24, 48, 48); 
			masked_blit(icons, buffer, 48, 0, p2.x-24, p2.y-24, 48, 48); 
			
			if (key[KEY_A])
			{
				rectfill(buffer, p1.x-15-3, p1.y-3, p1.x-15+3, p1.y+3, white);
			}
			if (key[KEY_D])
			{
				rectfill(buffer, p1.x+15-3, p1.y-3, p1.x+15+3, p1.y+3, white);
			}
			if (key[KEY_W])
			{
				rectfill(buffer, p1.x-3, p1.y-15-3, p1.x+3, p1.y-15+3, white);
			}
			if (key[KEY_S])
			{
				rectfill(buffer, p1.x-3, p1.y+15-3, p1.x+3, p1.y+15+3, white);
			}
			if (key[KEY_LEFT])
			{
				rectfill(buffer, p2.x-15-3, p2.y-3, p2.x-15+3, p2.y+3, white);
			}
			if (key[KEY_RIGHT])
			{
				rectfill(buffer, p2.x+15-3, p2.y-3, p2.x+15+3, p2.y+3, white);
			}
			if (key[KEY_UP])
			{
				rectfill(buffer, p2.x-3, p2.y-15-3, p2.x+3, p2.y-15+3, white);
			}
			if (key[KEY_DOWN])
			{
				rectfill(buffer, p2.x-3, p2.y+15-3, p2.x+3, p2.y+15+3, white);
			}		
			
			
			
			for (int i=0;i<colcount;i++)
			{
				masked_blit(icons, buffer, 96+48, 0, collectables[i].x-24, collectables[i].y-24, 48, 48); 
			}
			
			textout_ex(buffer, f,timetxt, 5, 5, white, -1);
			textout_ex(buffer, f,scoretxt, 5, 35, white, -1);
			
		}
	};

template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}


			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();



int storyprogress;
bool finishedstory;
int pauseafter;



class IntroLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare + pishtaco present", SCREEN_WIDTH/2, 4*10,white, -1);

		}
	};


class IntroDialogue
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			quit=false;

		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}
		
		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "increpare presents", 160, 4*10,white, -1);
			
		}
	};


class GameOverLoop
	{
	public:
		static void initialize()
		{

			spacepressed=true;
			quit=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{


			if ((key[KEY_ESC]&&!escpressed)||key[KEY_SPACE])
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, f, "your final score was:", 300, 5*10,white, -1);
			
			sprintf(scoretxt,"score:%d",score);
			textout_centre_ex(buffer, f, scoretxt, 300, 7*10,white, -1);
		}
	};


class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
	public:
		static void initialize()
		{
			levelseed=1;
			spacepressed=true;
			endmode=false;
			endmenutimer=0;
			quit=false;
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			leftheld=true;
			rightheld=true;
			talking=false;
			talkcount=0;
		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;


				return;
			}

			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

			
			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					upheld=true;
					playsample(1);
				}
			}
			else
				upheld=false;
			
			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					downheld=true;
					playsample(1);
				}
			}
			else
				downheld=false;
			
			
			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						randmusic();
						begin=true;
						endmenutimer=40;
					}
					else
					{
						randmusic();
						quit=true;
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;
			
		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
			blit(title, buffer,0,0,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			textout_right_ex(buffer,f,"period",700,40,makecol(255,255,255),-1);

			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,f," START ",260+50,420,bgcol,makecol(255,255,255));
				textout_ex(buffer,f," Exit ",260+50,440,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,f," Start ",260+50,420,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,f," EXIT ",260+50,440,bgcol,makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;

template<class T>
void loop()
{

	clear_to_color(buffer, bgcol);

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        blit(buffer, screen, 0, 0, 0,0,SCREEN_WIDTH, SCREEN_HEIGHT);

	}
}



void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, SCREEN_WIDTH,SCREEN_HEIGHT, 0, 0) ;

	red=makecol(255,0,0);
	lightred=makecol(255,200,200);
	pink=makecol(255,192,203);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(0,0,0);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);
	lightgreen=makecol(200,255,200);
	grey=makecol(100,100,100);
	lightgrey=makecol(200,200,200);
	orange=makecol(253,183,58);
	purp0=makecol(107,30,98);
	purp1=makecol(199,40,162);
	purp2=makecol(255,220,255);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	bg=load_bitmap("bmp/background.bmp",NULL);
	icons=load_bitmap("bmp/icons2.bmp",NULL);
	title=load_bitmap("bmp/title.bmp",NULL);
	f=load_bitmap_font("bmp/font.pcx",NULL,NULL);
	if (f==0)
	{
		exit(0);
	}
	
}

int dir;
int px;
int py;

bool gototitle=false;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:
	gototitle=false;

	randmusic();
	loop<TitleLoop>();

	if (quit)
		goto end;

	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}

	randmusic();
	playsample();
	loop<LevelLoop >();
	stopsample();
	
	if (finishedtitle)
		loop<GameOverLoop>();



menuskip:
	quit=false;
	finishedtitle=false;
	TitleLoop::begin=false;
	goto titletag;

end:
	quit=false;
	return 0;

}
END_OF_MAIN()
